#include "testlib.h"
#include <bits/stdc++.h>
 
using namespace std;
 
struct Constraints {
  int maxN, maxM, maxT;
};
 
const int MAX_N = 200'000;
const int MAX_M = 1'000'000'000;
const int MAX_T = 1'000'000'000;
 
vector<Constraints> groups = {
    {MAX_N, MAX_M, MAX_T}, 
    {500, 100, MAX_T},
    {MAX_N, 100, MAX_T},
    {500, MAX_M, 500},
    {5000, MAX_M, 500},
    {MAX_N, MAX_M, MAX_T}
};
 
/*
0) samples
1) small n, m
2) small m
3) small n, t
4) small t
5) full
*/
 
int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int group = validator.group() == "" ? 0 : stoi(validator.group());
    int n = inf.readInt(1, groups[group].maxN, "n");
    inf.readSpace();
    int m = inf.readInt(1, groups[group].maxM, "m");
    inf.readEoln();
    vector<int> t = inf.readInts(n, 0, groups[group].maxT, "t_i");
    for (int i = 0; i < n - 1; ++i) {
        ensuref(t[i] <= t[i + 1], "Times should be sorted");
    }
    inf.readEoln();
    inf.readEof();
}
