#include <iostream>
#include <vector>
#include <algorithm>
 
using namespace std;
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<pair<int, int>> s{{m, m}};
    for (int i = 0; i < n - 1; ++i) {
        if (a[i + 1] - a[i] <= m) continue;
        if (a[i + 1] - a[i] >= m + m) {
            cout << "-1\n";
            return 0;
        }
        int l = (a[i] + 1) % m;
        int r = a[i + 1] % m;
        if (l > r) {
            s.push_back({l, m - 1});
            s.push_back({0, r});
        } else {
            s.push_back({l, r});
        }
    }
    sort(s.begin(), s.end());
    int mx = -1;
    for (auto[l, r] : s) {
        if (l > mx + 1) {
            cout << mx + 1 << "\n";
            return 0;
        }
        mx = max(mx, r);
    }
    cout << "-1\n";
}
