#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) begin(a), end(a)
#define len(a) int((a).size())

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (auto &x : a) {
        cin >> x;
    }
    vector<pair<int, int>> segs;

    auto ban = [&](int l, int r) {
        segs.emplace_back(l, r);
    };

    for (int i = 0; i + 1 < n; i++) {
        int first = a[i] + 1;
        int last = a[i + 1] - 1;
        if (last - first + 1 >= m) {
            int start = first % m;
            int end = (last + 1) % m;
            if (start <= end) {
                ban(start, end);
            } else {
                ban(start, m - 1);
                ban(0, end);
            }
        }
    }
    sort(segs.begin(), segs.end());

    int last_active = 0;
    for (auto [l, r] : segs) {
        if (last_active < l) {
            cout << last_active << '\n';
            return 0;
        }
        last_active = max(last_active, r + 1);
    }

    if (last_active < m) {
        cout << last_active << '\n';
    } else {
        cout << "-1\n";
    }
}
