#include <iostream>
#include <algorithm>
#include <vector>
 
using namespace std;
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i] += m;
    }
    a.resize(unique(a.begin(), a.end()) - a.begin());
    for (int t = 0; t < m; ++t) {
        int ok = 1;
        int day = (a[0] - t) / m;
        for (int i = 1; i < n; ++i) {
            int cur = (a[i] - t) / m;
            if (cur > day + 1) {
                ok = 0;
                break;
            }
            day = cur;
        }
        if (ok) {
            cout << t << "\n";
            return 0;
        }
    }
    cout << "-1\n";
}
